#version 110

uniform float panoramabreedtereciprocal;
uniform float DELTA;

varying vec2 texcoord[3];

uniform sampler2D facetten; 

// R=pre0*post1 - post0*pre1 is voor +/- bewegingsdetectie
void berekenbeweging(in vec3 pre0,in vec3 pre1,in vec3 post0,in vec3 post1,out float overlap)
{

	vec3 tussenval=(((pre0)*(post1))- ((pre1)*(post0)));
/*
	if(abs(tussenval.r)>=abs(tussenval.g) && abs(tussenval.r)>=abs(tussenval.b)) overlap=tussenval.r;
	else if(abs(tussenval.g)>=abs(tussenval.b)) overlap=tussenval.g;
	else overlap=tussenval.b;*/
	overlap=tussenval.r+tussenval.g+tussenval.b;
}

void main()
{	
	vec3 l[2],r[2];
	
	
	float prevrespons=0.00;
	float respons=0.0;
	float speedofprevrespons=0.0;
	//float y=0.0;
	for(float afstand=DELTA;afstand<(1.0-(DELTA*1.0));afstand+=DELTA)
	{
		float averagerespons=0.0;
		float counter=0.0;
		float usefulcounter=0.0;
		for(float y=0.0;y<1.0  && y+afstand<=1.0 ;y+=DELTA)
		{
			counter+=1.0;
		
	
		
			l[1]=(texture2D(facetten,vec2(texcoord[0].s,y+afstand)).rgb);
			r[1]=(texture2D(facetten,vec2(texcoord[1].s,y+afstand)).rgb);

			l[0]=(texture2D(facetten,vec2(texcoord[0].s,y)).rgb);	
			r[0]=(texture2D(facetten,vec2(texcoord[1].s,y)).rgb);
		
		
		
			berekenbeweging(l[0],r[0],l[1],r[1],respons);
			if(abs(respons)>0.1) usefulcounter+=1.0;
			averagerespons+=respons;
		}
		respons=averagerespons/counter;
		
		if(abs(respons)>abs(prevrespons))// && counter>=usefulcounter-1.0)
		{
			prevrespons=respons;
			speedofprevrespons=1.0/((afstand*sign(respons))/DELTA);
	
		}
	}
	
	
	//gl_FragColor = vec4(clamp(-speedofprevrespons,0.0,1.0),clamp(speedofprevrespons,0.0,1.0),0,0);
	gl_FragColor = vec4(-speedofprevrespons*1.0,speedofprevrespons*1.0,0,0);
}


