#define EPSILON 0.01
#define STAPPEN 6
#define VOORRESOL 64
#define LATERESOL 32
#define BIJDIEPTE  4

#define WERELDTEXRESMULT 20.0
#define OBSTAKELSEGMENTEN 32.0
#define OBSTAKELLIJNSEGMENTEN 16.0

#define GRONDTEXMULT -1.0 //als -1.0 dan wordt mijnradius*2.0 gebruikt.

std::string creeernaam(int aantalsylaben);

class lopertje
{
public:
	lopertje(float min,float max,float power,float wrijvingkracht);
	lopertje();
	void vooruit();
	void achtuit();
	void update();
	
	float getWaarde();
	void zetmij(float min,float max,float power,float wrijvingkracht);
private:
	float mmn,mmx,mpw,mwk;
	float huidig;	
};

class bij
{
public:
	bij(); //initialisatie op 0,0,0
	bij(vect pos,class wereld *dewereld);
	void draw();
	void update();
	void draai();
	void doestap();
	void doestap(float delta);
	void twistandturn();
	void zetmij(vect pos,class wereld *dewereld);
	void randomize();
	void viewpoint();
	void zetwereld(class wereld *dewereld);
	bool benikklaarmetmijnlaatstestap();
	float welkerichtingvliegiknuop();
	vect getpos();
	vect getlaatstestap();
	float lengtelaatstestap();
	vect getwarped();
	bool didibump();
private:
//	framebufferobject *vooruit,*zijkant[2],*onder;
	class wereld *mijnwereld;
	vect mijnpos;
	vect laatstestap;
	vect vorigestappen[STAPPEN];
	float yawrot,pitchval;
	lopertje mijnspd,mijnyaw,mijnpitch;
	float delta_opgeteld;
	vect iwarpedthisfar;
	bool Ibumped;
};

struct lijnintersect
{
	lijnintersect();
	bool parallel;
	bool erisafstand;
	vect intersectie;
	bool isereenintersect;
	float afstand;
	void zetintersect(vect inter);
	void zetafstand(float nwafstand);
	void lijnenzijnparallelenoverlappen(vect inter);
	float bijposafstand;
};

struct obstakel //altijd zeskant? Is wel zo makkelijk
{
public:
	obstakel(vect pos,float rot,vect dimensies);
	obstakel(vect pos,float rad,float hoogte);
	obstakel();
	~obstakel();
	bool vrijepositie(vect pos);
	void draw();
	void berekenmij(vect pos,float rot,vect dimensies); //staat altijd op de grond? duz z negeren bij pos
	void berekenmij(vect pos,float rad,float hoogte);
	float vertices[8][3];
	vect punt[8];
	vect kleur;
	vect mijndims;
	vect center,grondcenter;
	vect mijndimoffset;
	float mijnrot;
	lijnintersect hoevermis(vect pos,vect bijpos);
	void drawlijntjes(float W,float H,float rad);
	bool benikrond;
	float mijnrad,mijnhoogte;
	
	void verwerkjeoverlaps(float wereldrad);
	int overhoeveelrandenligikheen;
	obstakel *klonen;
};

class wereld
{
public:
	wereld(float vloerradius,int hoeveelobstakels,class framebufferobject *textuur);
	~wereld();
	void draw();
	void drawforobservation();
	void drawlijntjes();
	bool vrijepositie(vect pos);
	bool vrijepositieomring(vect pos);
	void binddanstextuur();
	void binddansfb();
	float getradius();
	void iserraakgeschoten(float x,float z,vect bijpos);
	void printapocalyptica();
	float hoevermis(vect pos,vect bijpos);
	void savedanstextuur();
	int getdansdim();
	void dansnaarpng();
	void logtofile(std::string regel);
	void logtofile(std::string varname,int varval);
	void logtofile(std::string varname,float varval);
	void logtofile(std::string varname,double varval);
	void logtofile(std::string varname,bool varval);
	void logtofile(std::string varname,grondtexturen varval);
	void voegmijnstaptoe(float lengtestap);
private:
	std::string logos;
	std::ofstream logfile;
	int screenshotcounter;
	GLuint afbeelding;
	float mijnradius;
	int aantalobstakels;
	obstakel *mijnobstakels;
	obstakel muren[4];
	class framebufferobject *danstextuur,*pngtextuur,*gegenereerdetextuur;
	int raakgeschoten,misgeschoten;
	float opgeteldeminimaleafstand;
	double totaleafgelegdeafstand;
	int gezettestappen;

	
};
