#include <GL/glew.h>
#include <GL/freeglut.h>    
//#include <GL/gl.h>
//#include <GL/glu.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string>
#include <vector>
#include <time.h>
#include <iostream>
#include <fstream>
//#include "opencv2/opencv.hpp"
#include "vect.h"
#include "textfile.h"
#include "settings.h"
#include "wereld.h"
#include "framebufferabstract.h"
#include <sys/stat.h>
#include <string>
using namespace std;


#define SW 1920
#define SH 1080

#define ESCAPE 27
#define TEMPUPDATESPEED 0.1

#define RADtoDEGREE 180.0/M_PI

int beweeglatenzien=0;


bool tekengrondtextuuropscherm=false;
bij bees[AANTALBIJEN];
vect bijkleuren[AANTALBIJEN];
panorama panbij[AANTALBIJEN];
horizonfacetten facettenbij[AANTALBIJEN];
voetstaarder odometer[AANTALBIJEN];
vect locatie(0.0,-1.0,0.0);
float rot=0.0;

lopertje loper(-0.7,1.0,0.09,0.9);
lopertje draai(-0.5,0.5,0.09,0.6);

int welkerrichting=0;

bool moved=false;

bool pauze=false;
bool depthtekenen=false;
bool snelheidtekenen=false;
bool danstextuurtekenen=true;
bool bewegingsdetectietekenen=true;
int tekenmij=0;
bool tekenen=false;

time_t starttime;
time_t endtime=0;
int aantalupdates=0;

GLhandleARB bewegingsdetectiep,textuurp,difp,ommatidiap,odoommatidiap,celsamenp,diepteverwerkerp,edgep,odoedgep,distcalcp,bewegingsdetectieopdegrondp,distverwerkerp; 
framebufferobject *textuur;

bool teken[5]={true,false,true,true,false};
bool but[5]={false,false,false,false,false};

int window; 
int light=1;
int lp;
int fp;

bool mijnrotate=false;

GLfloat xrot;  
GLfloat yrot;  
GLfloat zrot;
GLfloat xspeed;
GLfloat yspeed;
GLfloat zspeed;
float posx=0,posy=-1.0,posz=-25;
vect beweeg;
GLfloat LightAmbient[] = { 0.1f, 0.1f, 0.1f, 1.0f };
GLfloat LightDiffuse[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat LightPosition[] = { 0.0f,15.0f,-2.0f, 1.0f };

GLvoid ReSizeGLScene(GLsizei Width, GLsizei Height)
{
    if (Height==0)	Height=1;

    glViewport(0, 0, Width, Height);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,1000.0f);
    glMatrixMode(GL_MODELVIEW);
}


GLuint wereldsurface;
wereld *hallo;

void killfunctie()
{

	if(CALCULATEPATH)
	{
		for(int i=0;i<AANTALBIJEN;i++)
		{
			vect huidigodopos(odometer[i].oedipos());
			vect huidigbijpos(bees[i].getpos());
			vect odolaatstestap(odometer[i].laatstestap());
			vect bijlaatstestap(bees[i].getlaatstestap());
	
			char positieoutput[256];
			float afstand=vectafstand(huidigodopos,huidigbijpos);
			sprintf(positieoutput,"Eindstand: Bij nr %d normaler heeft in werkelijkheid stap(%2.2f,%2.2f,%2.2f)naar(%3.1f,%3.1f,%3.1f) gezet, odometer denkt (%2.2f,%2.2f,%2.2f)naar(%3.1f,%3.1f,%3.1f)  en dat betekent dat de afstand tussen de twee posities %f is\n",i,bijlaatstestap.x,bijlaatstestap.y,bijlaatstestap.z,huidigbijpos.x,huidigbijpos.y,huidigbijpos.z,odolaatstestap.x,odolaatstestap.y,odolaatstestap.z,huidigodopos.x,huidigodopos.y,huidigodopos.z,afstand);
			printf("%s",positieoutput);
			hallo->logtofile(string(positieoutput));
		}
	}
	
	hallo->savedanstextuur();
//	hallo->printapocalyptica();
	hallo->logtofile("Aantal gemaakte updates",aantalupdates);
	endtime=time(NULL);
	hallo->logtofile("Aantal seconden runtime",(int)(endtime-starttime));
	hallo->logtofile("Dus tijd per bij per update",(((float)(endtime-starttime))/AANTALBIJEN)/((float)(aantalupdates)));
	glutLeaveMainLoop();

	
}

GLvoid InitGL(GLsizei Width, GLsizei Height)
{
	glEnable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE0);
	glEnable(GL_TEXTURE_2D);
	glActiveTexture(GL_TEXTURE1);
	glEnable(GL_TEXTURE_2D);
	
	glClearColor(0.2f, 0.2f, 0.7f, 0.0f);	// This Will Clear The Background Color To Black
	glClearDepth(1.0);				// Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);			// The Type Of Depth Test To Do
	glEnable(GL_DEPTH_TEST);			// Enables Depth Testing
	glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading
	//glEnable(GL_CULL_FACE);
	//glCullFace(GL_BACK);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();				// Reset The Projection Matrix
	gluPerspective(PERSPECTSPAN,(GLfloat)Width/(GLfloat)Height,0.1f,1000.0f);	// Calculate The Aspect Ratio Of The Window
	glMatrixMode(GL_MODELVIEW);

	glEnable(GL_COLOR_MATERIAL);
}

int countcountcount=0;
bool firsttry=true;

void algemene_update()
{
	aantalupdates++;
	
	if(countcountcount++>30)
	{
		hallo->savedanstextuur();
		countcountcount=0;
	}
	
	if(aantalupdates>MAXSTAPPEN && MAXSTAPPEN>0) //Exit!!
		killfunctie();

	for(int i=0;i<AANTALBIJEN;i++)
	{
		
		bees[i].update();
		bees[i].draai();
		
		for(int c=0;c<STAARTIJDRESOLUTIE;c++)
		{
			
			if(CALCULATEOBJECTS && c%STAARVERHOGER==0)
			{

				for(int buf=0;buf<PANSEG;buf++)
				{
					panbij[i].bindrenderbuffer(buf);
					glLoadIdentity();
					glUseProgramObjectARB(0);
					glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			
					glRotatef(panbij[i].draaiwereld(buf),0.0,1.0,0.0);
					bees[i].viewpoint();
			
					textuur->bindtexture();
					hallo->draw();
				}
		
			
				panbij[i].lijmbuffers();

			
				facettenbij[i].update();
			}
			
			
			if(CALCULATEPATH)
			{
				glPushMatrix();
				odometer[i].bindoogfb();
				glLoadIdentity();
				glUseProgramObjectARB(0);
				glClearColor(0.0f, 0.2f, 0.0f, 0.0f);
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			
				glRotatef(90.0,1.0,0.0,0.0);
				vect bijpos(bees[i].getpos());
				glTranslatef(-bijpos.x,-1.0,-bijpos.z); //vaste hoogte!
				//bees[i].viewpoint();
			
				textuur->bindtexture();
				hallo->draw();
			
				odometer[i].takeaslice();
				glPopMatrix();
				
			}
			
			bees[i].doestap(STAARDELTA);
			
		}
		
		if(!bees[i].benikklaarmetmijnlaatstestap()) printf("Bijtje[%d] is helemaal nog niet klaar met zijn laatste stap en toch wil je de gevonden data al verwerken... Hoezo dat dan?\n",i);
		
		
			
		if(CALCULATEOBJECTS && !USEOWNJUDGMENT) facettenbij[i].verwerkdata(bees[i].lengtelaatstestap());
		
		vect huidigodopos(0,0,0);
		
		vect huidigbijpos(bees[i].getpos());
		
		vect odolaatstestap(0,0,0);
		if(CALCULATEPATH)
		{
			if(firsttry)	odometer[i].setinitialpos(bees[i].getpos(),WERELDRADIUS);
			
			odolaatstestap.zetmij(odometer[i].verwerkdata(bees[i].getwarped()));
			
			if(USEOWNJUDGMENT && CALCULATEOBJECTS) facettenbij[i].verwerkdata(vectlengte(odolaatstestap));
			
		
			vect bijlaatstestap(bees[i].getlaatstestap());
			huidigodopos.zetmij(odometer[i].oedipos());
			
			
			
			char positieoutput[256];
			float afstand=vectafstand(huidigodopos,huidigbijpos);
			sprintf(positieoutput,"Bij nr %d normaler heeft in werkelijkheid stap(%2.2f,%2.2f,%2.2f)naar(%3.1f,%3.1f,%3.1f) gezet, odometer denkt (%2.2f,%2.2f,%2.2f)naar(%3.1f,%3.1f,%3.1f)  en dat betekent dat de afstand tussen de twee posities %f is\n",i,bijlaatstestap.x,bijlaatstestap.y,bijlaatstestap.z,huidigbijpos.x,huidigbijpos.y,huidigbijpos.z,odolaatstestap.x,odolaatstestap.y,odolaatstestap.z,huidigodopos.x,huidigodopos.y,huidigodopos.z,afstand);
		//	printf("%s",positieoutput);
			hallo->logtofile(string(positieoutput));
			
			if(RESETDISTANCE!=0.0 && afstand>RESETDISTANCE)
			{
				odometer[i].reset(huidigbijpos);
				sprintf(positieoutput,"Bij nr %d normaler is het spoor bijster en wordt gereset! Landmarks zouden veel schelen..\n",i);
				//printf("%s",positieoutput);
				hallo->logtofile(string(positieoutput));
			}
			
			
		}
		
		
		
		
		if(bees[i].lengtelaatstestap()>0.0 || (USEOWNJUDGMENT && vectlengte(odolaatstestap)>0.0))
		{
			//printf("telkemenm!\n");
			glDisable(GL_TEXTURE_2D);
			hallo->binddansfb();
			glUseProgramObjectARB(0);
			if(TEKENDANSALPHA){
				glEnable(GL_BLEND);
				glBlendEquationSeparate(GL_FUNC_ADD, GL_FUNC_ADD);
				glBlendFuncSeparate(GL_SRC_ALPHA, GL_DST_ALPHA, GL_ONE, GL_ONE);
			}
			glBegin(GL_POINTS);
			

			//glColor3f(1.0,0.0,0.0); glVertex3f(randfloat(-100.0,100.0),randfloat(-100.0,100.0),randfloat(-100.0,100.0));
			
			if(!USEOWNJUDGMENT && CALCULATEOBJECTS  && !bees[i].didibump())
			{
			//	vect beesposminhalvelaatstestap(vectminvect(bees[i].getpos(),vectmult(bees[i].getlaatstestap(),0.5))); // heb ik al rekening mee gehouden in distberekening
				facettenbij[i].geefvertexengevondenafstanden(bees[i].getpos(),bees[i].welkerichtingvliegiknuop(),bijkleuren[i],hallo);
				hallo->voegmijnstaptoe(bees[i].lengtelaatstestap());
			}
			
			if(USEOWNJUDGMENT && vectlengte(odolaatstestap)>0.05)
			{
				//vect beesposminhalvelaatstestap(vectminvect(huidigodopos,vectmult(odolaatstestap,0.5))); // heb ik al rekening mee gehouden
				facettenbij[i].geefvertexengevondenafstanden(huidigodopos,odometer[i].welkerichtinggaikop(),bijkleuren[i],hallo);
				hallo->voegmijnstaptoe(vectlengte(odolaatstestap));
			}
			
			if(BETERTEKENJELIJNEN && CALCULATEPATH)
			{
				glColor4f(1.0-bijkleuren[i].x,1.0-bijkleuren[i].y,1.0-bijkleuren[i].z,1.0);
				glVertex3f(huidigodopos.x,huidigodopos.z,0);
			}
				
			glEnd();  
			glBegin(GL_LINES);
			
			vect laatstestap(bees[i].getlaatstestap());
			glColor4f(bijkleuren[i].x,bijkleuren[i].y,bijkleuren[i].z,1.0);
			glVertex3f(huidigbijpos.x,huidigbijpos.z,0.0);
			glVertex3f(huidigbijpos.x-laatstestap.x,huidigbijpos.z-laatstestap.z,0.0);

			if(CALCULATEPATH){			
				glVertex3f(huidigbijpos.x,huidigbijpos.z,0.0);
				if(!BETERTEKENJELIJNEN) glColor4f(1.0-bijkleuren[i].x,1.0-bijkleuren[i].y,1.0-bijkleuren[i].z,1.0);
				else	glColor4f(bijkleuren[i].x,bijkleuren[i].y,bijkleuren[i].z,1.0);
				
				glVertex3f(huidigodopos.x,huidigodopos.z,0);

			}
			glEnd();
			if(TEKENDANSALPHA) glDisable(GL_BLEND);
			glEnable(GL_TEXTURE_2D);
		}
		
	}
	
	firsttry=false;
	
	hallo->drawlijntjes();

	
}





void drawquadsegmentofscreen(float screenw,float screenh,int wdiv,int hdiv,int x,int y)
{
	float segmentsizew=screenw/wdiv;
	float segmentsizeh=screenh/hdiv;
	//y=hdiv-y;
	drawtexturedquad(segmentsizew*x,segmentsizew+(segmentsizew*x),segmentsizeh+(segmentsizeh*y),segmentsizeh*y);
	
}

int cccur=0;
GLvoid DrawGLScene( )
{

	
	//if(!pauze && cccur%2==0) algemene_update();
	if(!pauze) algemene_update();
	
	glDisable(GL_DEPTH_TEST);
	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0,0,SW,SH);
	glOrtho(0,SW,0,SH,0.0f,10.0f);
	glMatrixMode(GL_MODELVIEW);
	glBindFramebuffer(GL_FRAMEBUFFER,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear The Screen And The Depth Buffer
	//glUseProgramObjectARB(bewegingsdetectiep);
	//glUniform1f(glGetUniformLocation(bewegingsdetectiep, "links_of_rechts") , 1.0);
	const int verticaalhoeveel=AANTALBIJEN;
	int horizontaalsegmenten=2;
	if(!(CALCULATEPATH && CALCULATEOBJECTS) && (CALCULATEPATH || CALCULATEOBJECTS)) horizontaalsegmenten=1;
	else if(!CALCULATEPATH && !CALCULATEOBJECTS) danstextuurtekenen=true;
	
	
	if(!tekengrondtextuuropscherm)
	{
		if(!danstextuurtekenen){
			for(int i=0;i<verticaalhoeveel;i++)
			{
				if(CALCULATEOBJECTS)
				{
					glUseProgramObjectARB(0);
					glActiveTexture(GL_TEXTURE0);
					glColor3f(1,1,1);
					//facettenbij[i].bindtexture(0);//cccur%2);
					 if(!depthtekenen){
					 	panbij[i].bindzichttexture();
					}else{
						panbij[i].binddieptetexture();
						colorvect(bijkleuren[i]);
					}
					drawquadsegmentofscreen(SW/horizontaalsegmenten,SH,1,verticaalhoeveel*3,0,(i*3)+1);
		
					glColor3f(1,1,1);
					glActiveTexture(GL_TEXTURE0);
					if(snelheidtekenen) facettenbij[i].bindtexture(1);
					else facettenbij[i].bindtexture(0);
					drawquadsegmentofscreen(SW/horizontaalsegmenten,SH,1,verticaalhoeveel*3,0,(i*3)+0);
			
					glColor3f(1,1,1);
					glActiveTexture(GL_TEXTURE0);
					if(bewegingsdetectietekenen) facettenbij[i].bindtexture(2);		
					else	facettenbij[i].bindtexture(3);		
		
					drawquadsegmentofscreen(SW/horizontaalsegmenten,SH,1,verticaalhoeveel*3,0,(i*3)+2);
				}
			
			
				if(CALCULATEPATH)
				{
					int offset=2;
					if(horizontaalsegmenten==1) offset=0;
					glColor3f(1,1,1);
					glActiveTexture(GL_TEXTURE0);
					odometer[i].bindtexture(0);
					drawquadsegmentofscreen(SW,SH,2*horizontaalsegmenten,verticaalhoeveel*2,offset+1,(i*2)+1);
			
			
					odometer[i].bindtexture(4+(welkerrichting*4));
					drawquadsegmentofscreen(SW,SH,2*horizontaalsegmenten,verticaalhoeveel*2,offset,(i*2)+1);
			
					odometer[i].bindtexture(2+(welkerrichting*4));
					drawquadsegmentofscreen(SW,SH,2*horizontaalsegmenten,verticaalhoeveel*2,offset+1,(i*2)+0);
			
					odometer[i].bindtexture(3+(welkerrichting*4));
					drawquadsegmentofscreen(SW,SH,2*horizontaalsegmenten,verticaalhoeveel*2,offset+0,(i*2)+0);
				}
			
			}		
		}else{
			glUseProgramObjectARB(0);
		
			glActiveTexture(GL_TEXTURE0);
			glColor3f(1,1,1);
			hallo->binddanstextuur();
			drawtexturedquad(0,SW,0,SH);
		
		
			if(false)//Onderstaande om de collisiondetection zichtbaar te maken, voor de zekerheid
			{
				glDisable(GL_TEXTURE_2D);
				glBegin(GL_POINTS); 
				glColor3f(0,0,1);
				for(float x=0;x<SW;x+=8.0)
				for(float y=0;y<SH;y+=8.0)
				{
					vect pos(WERELDRADIUS*((x-(SW/2.0))/(SW/2.0)),0,WERELDRADIUS*((y-(SH/2.0))/(SH/2.0)));
					float d=hallo->hoevermis(pos,bees[0].getpos());
					hallo->iserraakgeschoten(pos.x,pos.z,pos);
					glColor3f(d/10.0,1.0-(d),d/WERELDRADIUS);
					glVertex3f(x,SH-y,0);
				}
				glEnd();
				glEnable(GL_TEXTURE_2D);
			}
		
		}
	}else{
		glUseProgramObjectARB(0);
	
		glActiveTexture(GL_TEXTURE0);
		glColor3f(1,1,1);
		textuur->bindtexture();
		drawtexturedquad(0,SW,0,SH);
	}
	cccur=(cccur+1)%2;
	glDisable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glutSwapBuffers();
}


float valmove=0.1f;


/* The function called whenever a normal key is pressed. */
void keyPressed(unsigned char key, int x, int y) 
{
    /* avoid thrashing this procedure */
    usleep(100);
	int u=0;
	
    switch (key) {    
    case ESCAPE: // kill everything.
	/* shut down our window */
	killfunctie();              	
	break; // redundant.
	

    case 'S':
    case 's':
    	snelheidtekenen=!snelheidtekenen;
    	break;
    case 'P':
    case 'p':
    	pauze=!pauze;
    	break;
    case 'D':
    case 'd':
    	depthtekenen=!depthtekenen;
	break;
    case 'W':
    case 'w':
    	danstextuurtekenen=!danstextuurtekenen;
    	break;
    case 'T':
    case 't':
    	tekengrondtextuuropscherm=!tekengrondtextuuropscherm;
    	break;
    case 'y':
    case 'Y':
    	textuur->bindtexture();
    	textuur->saveaspng("textuur.png");
    	break;
    case 'Q':
    case 'q':
    	for(int i=0;i<AANTALBIJEN;i++)
		bees[i].twistandturn();
	break;
    case 'U':
    case 'u':
    	hallo->savedanstextuur();
    	break;
    case 'o':
    case 'O':
    	panbij[0].samenzicht[0]->saveaspng("UitzichtOpDeWereld.png");
    	break;
    case 'A':
    case 'a':
    	bewegingsdetectietekenen=!bewegingsdetectietekenen;
    	break;
    case 'z':
    case 'Z':
    	welkerrichting--;
    	if(welkerrichting<0) welkerrichting=0;
    	break;
    case 'x':
    case 'X':
    	welkerrichting++;
    	if(welkerrichting>=AANTALRICHTINGEN)welkerrichting=AANTALRICHTINGEN-1;
    	break;
    
    default:
    
		
	break;
    }	
}

/* The function called whenever a normal key is pressed. */
void specialKeyPressed(int key, int x, int y) 
{
    /* avoid thrashing this procedure */
    usleep(100);

    switch (key) {    
    case GLUT_KEY_PAGE_UP: // move the cube into the distance.
	zspeed-=0.003f;
	break;
    
    case GLUT_KEY_PAGE_DOWN: // move the cube closer.
	zspeed+=0.003f;
	break;


    case GLUT_KEY_UP:
    	/*//posz+=valmove;
    	moved=true;
    	
//    	vect locatie(0.0,0.0,0.0);

    	locatie.zetmij(vectplusvect(locatie,beweeg));*/
    	loper.vooruit();
    	break;
    case GLUT_KEY_DOWN:
    	/*//posz-=valmove;
    	moved=true;
    	beweeg.z=sinf(rot)*loopsnelheid*-1;
	beweeg.x=cosf(rot)*loopsnelheid*-1;
//    	vect locatie(0.0,0.0,0.0);

    	locatie.zetmij(vectplusvect(locatie,beweeg));*/
    	loper.achtuit();
    	break;
    	
    case GLUT_KEY_LEFT:
    	//moved=true;
    	//rot-=draaisnelheid;
    	draai.achtuit();
    	break;
    case GLUT_KEY_RIGHT:
    	//moved=true;
    	//rot+=draaisnelheid;
    	draai.vooruit();
    	break;

    default:
	break;
    }	
}

bool checkvoorshadercompileerfout(GLhandleARB shader,char* naam)
{
	GLint isCompiled = 0;
	glGetShaderiv(shader, GL_COMPILE_STATUS, &isCompiled);
	if(isCompiled == GL_FALSE)
	{
			GLint maxLength = 0;
			glGetShaderiv(shader, GL_INFO_LOG_LENGTH, &maxLength);
	 
			//The maxLength includes the NULL character
			std::vector<char> errorLog(maxLength);
			glGetShaderInfoLog(shader, maxLength, &maxLength, &errorLog[0]);
	 
			printf("Shadercompilatie van %s is gefaald..\nCheck dit: %s\n",naam,errorLog.data());
			glDeleteShader(shader); //Don't leak the shader.
			return false;
	}
	
	return true;
}


GLhandleARB createshader(char* vertshaderfilename,char* fragshaderfilename)
{
	bool foutmelding=false;
	char *vs,*fs;

	GLhandleARB v = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	GLhandleARB f = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);


	vs = textFileRead(vertshaderfilename);
	fs = textFileRead(fragshaderfilename);

	const char * ff = fs;
	const char * vv = vs;

	glShaderSourceARB(v, 1, &vv,NULL);
	glShaderSourceARB(f, 1, &ff,NULL);

	free(vs);
	free(fs);
	
	printf("Compiling %s...\n",vertshaderfilename);
	glCompileShaderARB(v);
	if(!checkvoorshadercompileerfout(v,(char *)"vertexshader")) foutmelding=true;
	
	printf("Compiling %s...\n",fragshaderfilename);
	glCompileShaderARB(f);	
	if(!checkvoorshadercompileerfout(f,(char *)"fragmentshader")) foutmelding=true;
	

	GLhandleARB prog = glCreateProgramObjectARB();
	
	glAttachObjectARB(prog,f);
	glAttachObjectARB(prog,v);

	glLinkProgramARB(prog);
	if(!foutmelding) return prog;
	else exit(1);
}

int main (int argc, char **argv)
{
	
	
 	srand(time(NULL));
    
  	
			
	glutInit(&argc, argv);  

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH);  

	glutInitWindowSize(SW, SH);  
	glutInitWindowPosition(0, 0);  
	window = glutCreateWindow("Land van melk en Honing");  
	GLenum err = glewInit();
	glutDisplayFunc(&DrawGLScene);  
	glutIdleFunc(&DrawGLScene);
	glutReshapeFunc(&ReSizeGLScene);
	glutKeyboardFunc(&keyPressed);
	glutSpecialFunc(&specialKeyPressed);
	glutFullScreen();
	
	if (GLEW_OK != err)
	{
	  /* Problem: glewInit failed, something is seriously wrong. */
	  fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
	  exit(1);
	}
   
	printf("Status: Using GLEW %s\n", glewGetString(GLEW_VERSION));
   	if (GLEW_ARB_vertex_shader && GLEW_ARB_fragment_shader) printf("Ready for GLSL\n");
	else{ printf("No GLSL support\n"); exit(1); }
	
	
 
 	textuur=new framebufferobject(1024,1024,true,false,true,true,true,false);
 	
 
 	switch(WELKEGRONDTEXTUUR)
 	{
 	case schaakbord:
 		textuurp=			createshader((char *)"toon.vert"	,(char *)"schaakbordgenereertextuur.frag");
 		break;
 	case ruis:
 		textuurp=			createshader((char *)"toon.vert"	,(char *)"ruisgenereertextuur.frag");
 		break;
 	case simplesinus:
 		textuurp=			createshader((char *)"toon.vert"	,(char *)"simplesinusgenereertextuur.frag");
 		break;
 	case horivertidia:
 		textuurp=			createshader((char *)"toon.vert"	,(char *)"horivertidiagenereertextuur.frag");
 		break;
 	case standaard:
 	default:
 		textuurp=			createshader((char *)"toon.vert"	,(char *)"origineelgenereertextuur.frag");
 		break;
 	}
 	
	difp=				createshader((char *)"difvertexshader.glsl",(char *)"diffragmentshader.glsl");
	bewegingsdetectiep=		createshader((char *)"horizontalebewegingsdetectievertexshader.glsl",(char *)"horizontalebewegingsdetectiefragmentshader.glsl");
	bewegingsdetectieopdegrondp=	createshader((char *)"horizontalebewegingsdetectievertexshader.glsl",(char *)"horizontalebewegingsdetectiefragmentshadervooropdegrond.glsl");
	ommatidiap=			createshader((char *)"horizontaleprefilter.vert",(char *)"horizontaleprefilter.frag");
	odoommatidiap=			createshader((char *)"horizontaleprefilter.vert",(char *)"odoprefilter.frag");
	celsamenp=			createshader((char *)"outputsamenvoeg.vert",(char *)"outputsamenvoeg.frag");
	diepteverwerkerp=		createshader((char *)"diepte.vert",(char *)"diepte.frag");
	edgep=				createshader((char *)"horizontaleedge.vert",(char *)"horizontaleedge.frag");
	if(!SINEGRADIENT) distcalcp=	createshader((char *)"horizontalafstandbepaling.vert",(char *)"horizontalafstandbepaling.frag");
	else	distcalcp=		createshader((char *)"horizontalafstandbepaling.vert",(char *)"horizontalafstandbepalingmetvariabeleinterommatidialeafstanden.frag");
	distverwerkerp=			createshader((char *)"horizontalafstandbepaling.vert",(char *)"distverwerker.frag");
	odoedgep=			createshader((char *)"horizontaleedge.vert",(char *)"odoedge.frag");
	
	glUseProgramObjectARB(distverwerkerp);
	glUniform1i(glGetUniformLocation(distverwerkerp, "facetten") , 0);
	
	glUseProgramObjectARB(distcalcp);
	glUniform1i(glGetUniformLocation(distcalcp, "facetten") , 0);
	glUniform1i(glGetUniformLocation(distcalcp, "oogindeling") , 1);
	
	glUseProgramObjectARB(edgep);
	glUniform1f(glGetUniformLocation(edgep, "panoramabreedtereciprocal") , 1.0/(PANHORIRESO));
	glUniform1i(glGetUniformLocation(edgep, "facetten") , 0);
	
	glUseProgramObjectARB(ommatidiap);
	glUniform1f(glGetUniformLocation(ommatidiap, "panoramabreedtereciprocal") , 1.0/(PANHORIRESO));
	glUniform1i(glGetUniformLocation(ommatidiap, "facetten") , 0);
	
	glUseProgramObjectARB(diepteverwerkerp);
	glUniform1i(glGetUniformLocation(diepteverwerkerp, "texture0") , 0);
	
	glUseProgramObjectARB(bewegingsdetectiep);
	glUniform1f(glGetUniformLocation(bewegingsdetectiep, "panoramabreedtereciprocal") , 1.0/(PANHORIRESO));
	glUniform1f(glGetUniformLocation(bewegingsdetectiep, "DELTA") , DELTA);
	glUniform1i(glGetUniformLocation(bewegingsdetectiep, "facetten") , 0);
	
	glUseProgramObjectARB(celsamenp);
	glUniform1f(glGetUniformLocation(celsamenp, "panoramabreedtereciprocal") , 1.0/(PANHORIRESO));
	glUniform1f(glGetUniformLocation(celsamenp, "DELTA") , DELTA);
	glUniform1i(glGetUniformLocation(celsamenp, "facetten") , 0);
	
	glUseProgramObjectARB(difp);
	glUniform1i(glGetUniformLocation(difp, "pre_translate") , 0);
	glUniform1i(glGetUniformLocation(difp, "posttranslate") , 1);
	
	glUseProgramObjectARB(bewegingsdetectieopdegrondp);
	glUniform1f(glGetUniformLocation(bewegingsdetectieopdegrondp, "panoramabreedtereciprocal") , 1.0/(RETINADIAMETER));
	glUniform1f(glGetUniformLocation(bewegingsdetectieopdegrondp, "DELTA") , STAARDELTA);
	glUniform1i(glGetUniformLocation(bewegingsdetectieopdegrondp, "facetten") , 0);
	
	glUseProgramObjectARB(odoedgep);
	glUniform1f(glGetUniformLocation(odoedgep, "panoramabreedtereciprocal") , 1.0/(RETINADIAMETER));
	glUniform1i(glGetUniformLocation(odoedgep, "facetten") , 0);
	
	glUseProgramObjectARB(odoommatidiap);
	glUniform1f(glGetUniformLocation(odoommatidiap, "panoramabreedtereciprocal") , 1.0/(RETINADIAMETER));
	glUniform1i(glGetUniformLocation(odoommatidiap, "facetten") , 0);
	
	glUseProgramObjectARB(textuurp);
	textuur->bindframebuffer();
	textuur->tekenquad();
	textuur->genereermipmaps();
	
	textuur->bindtexture();
	
	struct stat sb;

	if(!(stat("./screenshots", &sb) == 0 && S_ISDIR(sb.st_mode)))
	{
	    if(mkdir("./screenshots",S_IRWXU)==-1)
	    {
	    	printf("screenshots directory does not exist and cannot be created... exiting\n");
	    	exit(-1);
	    }
	}
	
	


	hallo=new wereld(WERELDRADIUS,WERELDOBSTAKELS,textuur);
	hallo->logtofile(string("\nWereld settings:\n"));
	hallo->logtofile(string("WERELDRADIUS"),WERELDRADIUS);
	hallo->logtofile(string("WERELDOBSTAKELS"),WERELDOBSTAKELS);
	hallo->logtofile(string("WELKEGRONDTEXTUUR"),WELKEGRONDTEXTUUR);
	hallo->logtofile(string("OBSTAKELMINRADIUS"),OBSTAKELMINRADIUS); 
	hallo->logtofile(string("OBSTAKELMAXRADIUS"),OBSTAKELMAXRADIUS); 
	hallo->logtofile(string("MAXSTAPPEN"),MAXSTAPPEN);
	hallo->logtofile(string("CALCULATEOBJECTS"),CALCULATEOBJECTS);
	hallo->logtofile(string("CALCULATEPATH"),CALCULATEPATH);
	
	if(CALCULATEOBJECTS)
	{
		hallo->logtofile(string("\nPanoramic system settings:\n"));
		hallo->logtofile(string("PANHORIRESO"),PANHORIRESO);
		hallo->logtofile(string("PANSEG"),PANSEG);
		hallo->logtofile(string("PANHOEK"),PANHOEK);
		hallo->logtofile(string("MAXDIST"),MAXDIST);
		hallo->logtofile(string("VERTICAALMINDER"),VERTICAALMINDER); 
		hallo->logtofile(string("SINEGRADIENT"),SINEGRADIENT);
		hallo->logtofile(string("CONSTANTADDITIVESINEGRADIENT"),CONSTANTADDITIVESINEGRADIENT);
		hallo->logtofile(string("DODEHOEK"),DODEHOEK);
		hallo->logtofile(string("VERWERKDISTANCE (Pointifying fields continuous distance fields)"),VERWERKDISTANCE);
	}
	
	if(CALCULATEPATH)
	{
		hallo->logtofile(string("\nOdometric system settings:\n"));
		hallo->logtofile(string("RETINADIAMETER"),RETINADIAMETER);
		hallo->logtofile(string("AANTALRICHTINGEN"),AANTALRICHTINGEN);
		hallo->logtofile(string("ODOKIJKHOEK"),ODOKIJKHOEK);
		hallo->logtofile(string("OOGMULT"),OOGMULT);
		hallo->logtofile(string("RESETDISTANCE (0.0==none)"),RESETDISTANCE);
		hallo->logtofile(string("USEOWNJUDGMENT"),USEOWNJUDGMENT);
	}
	
	hallo->logtofile(string("\nBij settings:\n"));
	hallo->logtofile(string("AANTALBIJEN"),AANTALBIJEN);
	hallo->logtofile(string("BIJRADIUS"),BIJRADIUS);
	hallo->logtofile(string("BIJSPEED"),BIJSPEED);
	hallo->logtofile(string("USEBIJSPEEDDIRECTLY"),USEBIJSPEEDDIRECTLY); 
	
	hallo->logtofile(string("\nDisplay settings:\n"));
	hallo->logtofile(string("TEKENTEXTUURINPLAATSZWART"),TEKENTEXTUURINPLAATSZWART);
	hallo->logtofile(string("TEKENDANSALPHA"),TEKENDANSALPHA);
	hallo->logtofile(string("ALPHAPUNTJES"),ALPHAPUNTJES);
	hallo->logtofile(string("BETERTEKENJELIJNEN"),BETERTEKENJELIJNEN);
	
	hallo->logtofile(string("\nTime resolution and related settings:\n"));
	if(CALCULATEOBJECTS)
	{
		hallo->logtofile(string("TIJDRESOLUTIE"),TIJDRESOLUTIE);
		hallo->logtofile(string("DELTA"),DELTA);
	}
	if(CALCULATEPATH)
	{
		hallo->logtofile(string("STAARVERHOGER"),STAARVERHOGER);
		hallo->logtofile(string("STAARTIJDRESOLUTIE"),STAARTIJDRESOLUTIE);
		hallo->logtofile(string("STAARDELTA"),STAARDELTA);
	}
	



  	for(int i=0;i<AANTALBIJEN;i++)
  	{
		
		bees[i].zetwereld(hallo);
		bees[i].randomize();
		bijkleuren[i]=vect(randfloat(0.0,1.0),randfloat(0.0,1.0),randfloat(0.0,1.0));
		while(bijkleuren[i].x<0.6 && bijkleuren[i].y<0.6 && bijkleuren[i].z<0.6) bijkleuren[i]=vect(randfloat(0.0,1.0),randfloat(0.0,1.0),randfloat(0.0,1.0));
		
	}
	
	if(CALCULATEOBJECTS)
	{
		for(int i=0;i<AANTALBIJEN;i++)
	  			panbij[i].initialiseer(PANSEG,PANHOEK,PANHORIRESO,diepteverwerkerp);
	  			
	  	for(int i=0;i<AANTALBIJEN;i++)	
	  	{	
	  		facettenbij[i].initialiseer(&panbij[i],PANHORIRESO,TIJDRESOLUTIE,bewegingsdetectiep,ommatidiap,edgep,distcalcp); //als aantalcellen *2 panoramacellen is dan overkom je nyquist supermakkelijk?
	  		if(VERWERKDISTANCE) facettenbij[i].zetdistbewerkerp(distverwerkerp);
	  	}
  	}
  	
  	if(CALCULATEPATH)
  	{
	  	for(int i=0;i<AANTALBIJEN;i++)
	  	{
	  		odometer[i].initialiseer(RETINADIAMETER,AANTALRICHTINGEN,STAARTIJDRESOLUTIE,ODOKIJKHOEK,OOGMULT,bewegingsdetectieopdegrondp,odoommatidiap,odoedgep); 
	  		odometer[i].setinitialpos(bees[i].getpos(),WERELDRADIUS);
	  	}
	}
	starttime=time(NULL);
	glutMainLoop();  	
	glutDestroyWindow(window); 
	
	delete hallo;	
	delete textuur;
	hallo=NULL;
	textuur=NULL;
	
	

       return 0;
}


